-----------------------
-- Wired             --
-- By: Wire @ Byriel --
-----------------------

Wired.Persistence = {};

Wired.Persistence.Constants = {
  Root = "Root"
};

-- functions

-- name
local GetName = function(sender)
  return sender.data.name;
end

local SetName = function(sender, value)
  sender.data.name = value;
end

-- root
local GetRoot = function(sender)
  return sender.data.root;
end

local SetRoot = function(sender, value)
  sender.data.root = value;
end

-- parent
local GetParent = function(sender)
  return sender.data.parent;
end

local SetParent = function(sender, value)
  sender.data.parent = value;
end

-- path
local GetPath = function(sender)
  local result = sender:GetRoot();
  if (sender:GetParent()) then
    result = sender:GetParent().Wired.Persistence:GetPath();
  end
  if (type(result[sender:GetName()]) ~= "table") then
    result[sender:GetName()] = {};
  end
  return result[sender:GetName()];
end

-- enable
local Enable = function(sender, name, root)
  -- add data
  if (not sender.data) then
    sender.data = {};
  end

  -- add parameters
  sender:SetName(name);
  sender:SetParent(sender:GetComponent():GetParent());
  sender:SetRoot(root);
end

-- add persistence context to component
Wired.Persistence.Wire = function(context, component)

  -- add persistence context
  if (type(context.Persistence) ~= "table") then
    context.Persistence = {};
    Wired.Wire(context.Persistence, component);

    -- add persistence functions
    context.Persistence.Enable = Enable;
    context.Persistence.EnableRoot = EnableRoot;
    context.Persistence.GetName = GetName;
    context.Persistence.SetName = SetName;
    context.Persistence.GetRoot = GetRoot;
    context.Persistence.SetRoot = SetRoot;
    context.Persistence.GetParent = GetParent;
    context.Persistence.SetParent = SetParent;
    context.Persistence.GetPath = GetPath;
  end
end
