-----------------------
-- Wired             --
-- By: Wire @ Byriel --
-----------------------

Wired.Persistence.PersistentVariable = class();

function Wired.Persistence.PersistentVariable:Constructor(name, parent, defaultValue)

  -- wire
  Wire(self);

  -- parameters
  self:SetName(name);
  self:SetParent(parent);
  self:SetDefaultValue(defaultValue);
end

-- getters and setters

-- name
function Wired.Persistence.PersistentVariable:GetName()
  return self.name;
end

function Wired.Persistence.PersistentVariable:SetName(value)
  self.name = value;
end

-- parent
function Wired.Persistence.PersistentVariable:GetParent()
  return self.parent;
end

function Wired.Persistence.PersistentVariable:SetParent(value)
  self.parent = value;
end

-- default value
function Wired.Persistence.PersistentVariable:GetDefaultValue()
  return self.defaultValue;
end

function Wired.Persistence.PersistentVariable:SetDefaultValue(value)
  self.defaultValue = value;
end

-- value
function Wired.Persistence.PersistentVariable:GetValue()
  local path = self:GetParent().Wired.Persistence:GetPath();
  local result = path[self:GetName()]
  if ((result == nil) and (self:GetDefaultValue() ~= nil)) then
    result = self:GetDefaultValue();
  end
  return result;
end

function Wired.Persistence.PersistentVariable:SetValue(value)
  local path = self:GetParent().Wired.Persistence:GetPath();
  if (path[self:GetName()] ~= value) then
    path[self:GetName()] = value;

    -- fire value changed event
    self:FireValueChanged();
  end
end

-- value changed
function Wired.Persistence.PersistentVariable:FireValueChanged()
  if (type(self.Wired.Event.ValueChanged) == "function") then
    self.Wired.Event:ValueChanged();
  end
end
