-----------------------
-- Wired             --
-- By: Wire @ Byriel --
-----------------------

Wired.UI.ColorPicker.Slider = class(Wired.UI.Slider);

-- constants
Wired.UI.ColorPicker.Slider.Constants = {
  
};

-- defaults
Wired.UI.ColorPicker.Slider.Defaults = {
  Scale = 255,
  Value = 127,
  Selected = 127
};

function Wired.UI.ColorPicker.Slider:Constructor(name, parent, component)
  Wired.UI.Slider.Constructor(self, name, parent);
  
  -- parameters
  self:SetComponent(component);
  
  -- defaults
  self:ApplyColorPickerSliderDefaults()
end

-- component
function Wired.UI.ColorPicker.Slider:GetComponent()
  if (not self.component) then
    self.component = Wired.UI.ColorPicker.Component.Red;
  end
  return self.component;
end

function Wired.UI.ColorPicker.Slider:SetComponent(value)
  self.component = value;
end

-- defaults
function Wired.UI.ColorPicker.Slider:ApplyColorPickerSliderDefaults()
  self:SetScale(Wired.UI.ColorPicker.Slider.Defaults.Scale);
  self:SetValue(Wired.UI.ColorPicker.Slider.Defaults.Value);
  self:SetSelected(Wired.UI.ColorPicker.Slider.Defaults.Selected);
end

-- color
function Wired.UI.ColorPicker.Slider:ScaleColor()
  self:GetBar():SetColor(Wired.UI.Color(
    (self:GetValue() / self:GetScale()) * self:GetComponent():GetRed(),
    (self:GetValue() / self:GetScale()) * self:GetComponent():GetGreen(),
    (self:GetValue() / self:GetScale()) * self:GetComponent():GetBlue(),
    1
  ));
end
